#ifndef FTABLE_H
#define FTABLE_H

#include <stdbool.h>
#include <sys/stat.h>

typedef struct NameList {
   char* path;
   struct NameList* next;
} NameList;
typedef struct FileTableEntry {
   dev_t device;
   ino_t inode;
   NameList* hardlinks;
   NameList* symlinks;
   struct FileTableEntry* next; // private please
} FileTableEntry;
typedef struct FileTable FileTable;

FileTable* ftable_create();
bool ftable_add(FileTable* ft, dev_t device, ino_t inode, char* path);
bool ftable_add_symlink(FileTable* ft, dev_t device, ino_t inode,
   char* symlink_path);
void ftable_start(FileTable* ft);
FileTableEntry* ftable_next(FileTable* ft);

#endif
